unit ControlPanel;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TControl_Panel = class(TForm)
    StaticText1: TStaticText;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    StaticText9: TStaticText;
    StaticText10: TStaticText;
    procedure ClearImage(Sender: TObject);
    procedure Finish(Sender: TObject);
    procedure Interpolation(Sender: TObject);
    procedure SetDraw2D(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Control_Panel: TControl_Panel;
  x            : array [1..15] of Double;

implementation

uses Graph2d_256_Interpol;

{$R *.DFM}

procedure TControl_Panel.ClearImage(Sender: TObject);
begin
  With Draw2D do
  begin
    ClearImage(slWhite);
    XScale(x1,x2,0,clRed);YScale(y1,y2,0,clRed);
  end;
  Index:=0;
end;

procedure TControl_Panel.Finish(Sender: TObject);
begin
  Draw2D.Visible:=False;halt;
end;

procedure TControl_Panel.Interpolation(Sender: TObject);
var i,j,n:Integer;
    c,b  :array [1..15] of Double;
    a    :array [1..15,1..15] of Double;
    hx,Trezor     :Double;
    Red,Green,Blue:Byte;
    HustotaKrivky :Integer;

    Function Mocnina(zaklad:Double;Exponent:Integer):Double;
    var Moc    :Double;
        i,Exp  :Integer;
    begin
      Exp:=Abs(Exponent);Moc:=1;
      if Exp<>0 then for i:=1 to Exp do Moc:=Moc*Zaklad;
      if Exponent<0 then Moc:=1/Moc;
      Mocnina:=Moc;
    end;

  procedure GEM;
    var i,j,k,l,r:Integer;
    begin
      {****  Gaussova elimin. metoda **********}
       for i:=1 to n-1 do                    {Postup po hl. diagonale}
       begin
           if abs(a[i,i])<1e-8 then          {Na hl. diagonale nula}
       begin
        l:=i;
        Repeat                               {Nalezeni nenuloveho prvku}
           l:=succ(l);
        until (a[l,i]<>0) or (l=n);
        if (a[i,i]=0) and (i=n) then exit;   {Nenulovy prvek nenalezen}
        for r:=i to n do                     {Prehozeni radku}
           begin
             Trezor:=a[l,r];a[l,r]:=a[i,r];
             a[i,r]:=Trezor;
           end;                              {Prehozeni radku}
        Trezor:=b[l];b[l]:=b[i];b[i]:=Trezor;{Prehozeni pravych stran}
       end;                                  {Na hl. diagonale nula}
       for k:=i+1 to n do                    {Nulovani pod a[i,i]}
       begin
         Trezor:=a[k,i]/a[i,i];
         for j:=i to n do
            a[k,j]:=a[k,j]-Trezor*a[i,j];
         b[k]:=b[k]-Trezor*b[i];             {Eliminace prave strany}
      end;                                   {Nulovani pod a[i,i]}
    end;                                     {Postup po hl. diagonale}
{*** Zpetny chod **********}
    if a[n,n]=0 then exit;
    for i:=1 to n do x[i]:=0;
    x[n]:=b[n]/a[n,n];
    for i:=n-1 downto 1 do                   {Zpet po hl. diaginale}
    begin
      for j:=i+1 to n do
          x[i]:=x[i]+a[i,j]*x[j];            {Secteni radku}
       x[i]:=(b[i]-x[i])/a[i,i];             {vypocet i-te slozky reseni}
    end;                                     {Zpet po hl. diagonale}
  end;

begin
  n:=index;
  if n=1 then
          begin messagedlg('Set Points by Mouse!',mterror,[mbok],0);exit;end;

  With Draw2D do hx:=(x2-x1)/n;
  {**** generovani soustavy ********}
  for i:=1 to n do for j:=1 to n do a[i,j]:=0;
  for i:=1 to n do
     begin
     for  j:=1 to n do a[i,j]:=Mocnina(Draw2D.P[i-1,1],j-1);
     b[i]:=Draw2D.P[i-1,2];
     end;

  {**** Gaussova eliminacni metoda ****}
  GEM;

  {***** sestrojeni polynomu *******}
  HustotaKrivky:=200;
  With Draw2D do
   begin Q[0,1]:=x1;hx:=(x2-x1)/HustotaKrivky;
  For i:=1 to HustotaKrivky-1 do Q[i,1]:=Q[i-1,1]+hx;
  for i:=0 to HustotaKrivky-1 do Q[i,2]:=0;
  for i:=0 to HustotaKrivky-1 do
    for j:=1 to n do Q[i,2]:=Q[i,2]+x[j]*Mocnina(Q[i,1],j-1);
  PolyLine(Q,HustotaKrivky,slBlue);
  Image1.Repaint;
  end;
  end;

procedure TControl_Panel.SetDraw2D(Sender: TObject);
begin
  Application.CreateForm(TDraw2D, Draw2D);
  With Draw2D do
  begin
   InitImage(500,500);ClearImage(slWhite);
   Caption:='Interpolation';
   Visible:=True;
   x1:=-5;x2:=5;y1:=-6;y2:=6;Scale(x1,x2,y1,y2);
   XScale(x1,x2,0,clRed);YScale(y1,y2,0,clRed);
   index:=0;
  end;
end;
end.
